﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Game
{
    /// <summary>
    /// Game类   游戏所有参数
    /// </summary>
    public class Game
    {
        List<PlayerGame> PlayerList = new List<PlayerGame>();
        public string GameName { get; set; }
        public int GameWidth { get; set; }
        public GridType[] Map { get; private set; }
        UI Ui;
        public Game(string gameName, int gameWidt)
        {
            GameName = gameName;
            GameWidth = gameWidt;
            Ui = new UI(gameName, gameWidt);
        }
        /// <summary>
        /// 根据位置获取玩家
        /// </summary>
        /// <param name="Schedule"></param>
        public List<PlayerGame> GetPlayerGameBySchedule(int Schedule)
        {
            List<PlayerGame> PlayerGameList = new List<PlayerGame>();
            foreach (PlayerGame PG in PlayerList)
            {
                if (PG.Schedule == Schedule)
                {
                    PlayerGameList.Add(PG);
                }
            }
            return PlayerGameList;
        }
        /// <summary>
        /// 获得排名
        /// </summary>
        /// <returns></returns>
        public List<PlayerGame> GetPlaySortList()
        {
            List<PlayerGame> Result = new List<PlayerGame>();
            foreach (PlayerGame PG in PlayerList)
            {
                Result.Add(PG);
            }
            Result.Sort();
            return Result;
        }
        /// <summary>
        /// 输出某一块地图  有玩家在上面的话输出玩家姓名
        /// </summary>
        /// <param name="Key"></param>
        public string WriteGrid(int Key)
        {
            string Result = "";
            if (Key < Map.Length)
            {
                List<PlayerGame> Temp = GetPlayerGameBySchedule(Key);
                if (Temp.Count <= 0)
                {
                    Result = Map[Key].Ico;
                }
                else
                {
                    Result = "[";
                    for (int i = 0; i < Temp.Count; i++)
                    {
                        if (i > 0)
                            Result += ",";
                        Result += Temp[i].Name;
                    }
                    Result += "]";
                    if (Result.RealLength() % 2 == 1)
                        Result += " ";
                }
            }
            return Result;
        }
        /// <summary>
        /// 输出地图  并计算字符长度
        /// </summary>
        /// <param name="Key">位置</param>
        /// <param name="TempLength">全局变量 长度</param>
        /// <returns></returns>
        public string WriteGrid(int Key, ref int TempLength)
        {
            string Result = "";
            if (Key < Map.Length)
            {
                List<PlayerGame> Temp = GetPlayerGameBySchedule(Key);
                if (Temp.Count <= 0)
                {
                    Result = Map[Key].Ico;
                    TempLength += 2;
                }
                else
                {
                    Result = "[";
                    for (int i = 0; i < Temp.Count; i++)
                    {
                        if (i > 0)
                            Result += ",";
                        Result += Temp[i].Name;
                    }
                    Result += "]";
                    if (Result.RealLength() % 2 == 1)
                        Result += " ";
                    TempLength += Result.RealLength();
                }
            }
            return Result;
        }
        /// <summary>
        /// 显示地图
        /// </summary>
        public void ShowMap()
        {
            ///正向还是逆向
            bool Reverse = false;
            ///已输出个数
            int Temp = 0;
            Console.WriteLine();
            do
            {
                int TempLength = 0;
                if (Reverse)
                {
                    List<string> StrList = new List<string>();
                    while (TempLength < GameWidth && Temp < Map.Length)
                    {
                        StrList.Add(WriteGrid(Temp++, ref TempLength));
                    }
                    for (int i = StrList.Count; i > 0; i--)
                    {
                        Console.Write(StrList[i - 1]);
                    }
                        Console.WriteLine();
                    for (int i = 0; i < 3; i++)
                    {
                        Console.WriteLine(WriteGrid(Temp++));
                    }
                    Reverse = !Reverse;
                }
                else
                {
                    while (TempLength < GameWidth && Temp < Map.Length)
                    {
                        Console.Write(WriteGrid(Temp++, ref TempLength));
                    }
                    Console.WriteLine();
                    for (int j = 0; j < 3; j++)
                    {
                        if (Temp < Map.Length)
                        {
                            for (int i = 0; i < GameWidth - 2; i++)
                            {
                                Console.Write(" ");
                            }
                            Console.WriteLine(WriteGrid(Temp++));
                        }
                    }
                    Reverse = !Reverse;
                }
            } while (Temp < Map.Length);
        }
        /// <summary>
        /// 输出玩家列表
        /// </summary>
        public void ShowPlayerList(int PlayerIndex)
        {
            for (int i = 0; i < PlayerList.Count; i++)
            {
                Console.Write("玩家{0}: {1}", i + 1, PlayerList[i].Name);
                if (i == PlayerIndex)
                {
                    Console.WriteLine(" ←");
                }
                else
                {
                    Console.WriteLine();
                }
            }
        }
        /// <summary>
        /// 添加游戏玩家
        /// </summary>
        public void PlayerLogin()
        {
            string PlayerName = null;
            do
            {
                Console.WriteLine("请输入第{0}个玩家的姓名(按回车健提交,输入'end'结束)", PlayerList.Count + 1);
                PlayerName = Console.ReadLine();
                if (PlayerName == "end" && PlayerList.Count < 2)
                {
                    Console.WriteLine("玩家不能少于两位");
                }
                else if (PlayerExist(PlayerName))
                {
                    Console.WriteLine("该玩家已存在");
                }
                else if (PlayerName.Length <= 0)
                {
                    Console.WriteLine("玩家姓名不能为空");
                }
                else
                {
                    Console.Clear();
                    Ui.ShowGameName();
                    if (PlayerName != "end")
                    {
                        PlayerList.Add(new PlayerGame(PlayerName));
                        for (int i = 0; i < PlayerList.Count; i++)
                        {
                            Console.WriteLine("玩家{0} {1}", i + 1, PlayerList[i].Name);
                        }
                    }
                    else
                    {
                        ShowPlayerList(0);
                    }
                }

            } while (PlayerName != "end" || PlayerList.Count < 2);
        }
        /// <summary>
        /// 判断玩家是否存在
        /// </summary>
        /// <param name="playerName">玩家姓名</param>
        /// <returns></returns>
        public bool PlayerExist(string playerName)
        {
            bool Exist = false;
            foreach (PlayerGame p in PlayerList)
            {
                if (p.Name == playerName)
                {
                    Exist = true;
                }
            }
            return Exist;
        }
        /// <summary>
        /// 触发事件   先用此方法实现  以后再改为委托
        /// </summary>
        /// <param name="grid"></param>
        /// <param name="player"></param>
        /// <param name="PlayerIndex"></param>
        /// <param name="ui"></param>
        public void Trigger(GridType grid, PlayerGame player, ref int PlayerIndex, UI ui)
        {
            uint RandomNumber = 0;
            if (player.Suspend == null)
            {
                Console.Clear();
                ui.ShowGameName();
                ShowPlayerList(PlayerIndex);
                ShowMap();
                if (grid.Value != 0)
                {
                    Console.WriteLine();
                    Console.WriteLine("{0} 触发了{1},{2}", player.Name, grid.Name, grid.Intro);
                    Console.ReadKey();
                }
                switch (grid.Value)
                {
                    case 1:
                        RandomNumber = (uint)ui.dice(3, 7);
                        player.Schedule += RandomNumber;
                        Console.WriteLine("掷出 {0},前进{1}格", RandomNumber, RandomNumber);
                        Console.ReadKey();
                        if (GetPlaySortList()[GetPlaySortList().Count - 1].Schedule < Map.Length && Map[player.Schedule].Value != 0)
                        {
                            Trigger(Map[player.Schedule], player, ref PlayerIndex, ui);
                        }
                        break;
                    case 2:
                        RandomNumber = (uint)ui.dice(2, 6);
                        Console.WriteLine("掷出 {0},后退{1}格", RandomNumber, RandomNumber);
                        if (player.Schedule >= RandomNumber)
                        {
                            player.Schedule -= RandomNumber;
                        }
                        else
                        {
                            player.Schedule = 0;
                        }
                        if (Map[player.Schedule].Value != 0)
                        {
                            Trigger(Map[player.Schedule], player, ref PlayerIndex, ui);
                        }
                        break;
                    case 3:
                        RandomNumber = (uint)ui.dice(0, 2);
                        Console.Write("掷出 {0}, ", RandomNumber);
                        if (RandomNumber == 0)
                        {
                            Console.WriteLine("判定不生效,未获得连续掷色子的机会");
                        }
                        else
                        {
                            Console.Write("判断生效");
                            PlayerIndex--;
                        }
                        break;
                    case 4:
                        RandomNumber = (uint)ui.dice(0, 2);
                        Console.Write("掷出 {0}, ", RandomNumber);
                        if (RandomNumber == 0)
                        {
                            Console.WriteLine("判定不生效,下次将可继续掷色子");
                        }
                        else
                        {
                            Console.Write("判断生效,将暂停一轮");
                            player.Suspend = true;
                        }
                        break;
                }
            }
        }
        public void GameLogin()
        {
            //显示有些名称
            Ui.ShowGameName();
            //初始化地图
            Map = Ui.Map(100);
            //记录游戏玩家
            Console.WriteLine("游戏规则：");
            foreach (GridType GT in Ui.GridTypes)
            {
                Console.WriteLine();
                Console.WriteLine("{0}:{1}({2})", GT.Ico, GT.Name, GT.Intro);
            }
            Console.WriteLine();
            Console.WriteLine("玩家积分大于等于100获得胜利,游戏结束.");
            Console.WriteLine();
            Console.WriteLine("按任意键进入游戏...");
            Console.ReadKey();
            Console.Clear();
            Ui.ShowGameName();
            PlayerLogin();
            int PlayerIndex = 0;
            int Count = 0;
            while (GetPlaySortList()[GetPlaySortList().Count - 1].Schedule < Map.Length)
            {
                Console.Clear();
                Ui.ShowGameName();
                ShowPlayerList(PlayerIndex);
                ShowMap();
                Console.WriteLine();
                if (Count != 0)
                {
                    Console.WriteLine("玩家：{0}抛出{1},前进{2}格.", PlayerList[PlayerIndex].Name, Count, Count);
                    if (Map[PlayerList[PlayerIndex].Schedule].Value != 0)
                        Trigger(Map[PlayerList[PlayerIndex].Schedule], PlayerList[PlayerIndex], ref PlayerIndex, Ui);
                    PlayerIndex++;
                    if (PlayerIndex >= PlayerList.Count)
                    {
                        PlayerIndex = 0;
                    }
                    Console.ReadKey();
                }
                if (PlayerList[PlayerIndex].Suspend == true)
                {
                    PlayerList[PlayerIndex].Suspend = false;
                    PlayerIndex++;
                    if (PlayerIndex >= PlayerList.Count)
                    {
                        PlayerIndex = 0;
                    }
                }
                else
                {
                    PlayerList[PlayerIndex].Suspend = null;
                }
                Console.Clear();
                Ui.ShowGameName();
                ShowPlayerList(PlayerIndex);
                ShowMap();
                Console.WriteLine();
                Console.WriteLine("玩家  {0}  获得神的青睐,获得一次掷色子的机会！", PlayerList[PlayerIndex].Name);
                Console.WriteLine("{0}  请按任意键掷色子", PlayerList[PlayerIndex].Name);
                Console.ReadKey();
                Count = Ui.dice();
                PlayerList[PlayerIndex].Schedule += (uint)Count;
            }
            Console.Clear();
            Ui.ShowGameName();
            Console.WriteLine();
            Console.WriteLine("Game Over");
            Console.WriteLine("得分排行榜");
            Console.WriteLine("名次\t玩家姓名\t得分");
            List<PlayerGame> paihangbang = GetPlaySortList();
            for (int i = paihangbang.Count - 1; i >= 0; i--)
            {
                Console.WriteLine("{0}\t{1}\t\t{2}", paihangbang.Count - i, paihangbang[i].Name, paihangbang[i].Schedule);
            }
            Console.WriteLine("按任意键退出游戏（先不考虑重玩）");
            Console.ReadKey();
        }
    }
}
