﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Game
{
    /// <summary>
    /// UI类  负责游戏界面及相关
    /// </summary>
    public class UI
    {
        public string GameName { set; get; }
        public int UIWidth { get; set; }
        public void ShowGameName()
        {
            for (int i = 0; i < UIWidth; i++)
            {
                Console.Write("*");
            }
            Console.WriteLine();
            Console.Write("*");
            for (int i = 0; i < UIWidth - 2; i++)
            {
                Console.Write(" ");
            }
            Console.WriteLine("*");
            Console.Write("*");
            for (int i = 0; i < (UIWidth - GameName.RealLength()) / 2 - 1; i++)
            {
                Console.Write(" ");
            }
            Console.Write(GameName);
            for (int i = 0; i < UIWidth - (UIWidth - GameName.RealLength()) / 2 - 1 - GameName.RealLength(); i++)
            {
                Console.Write(" ");
            }
            Console.WriteLine("*");
            Console.Write("*");
            for (int i = 0; i < UIWidth - 2; i++)
            {
                Console.Write(" ");
            }
            Console.WriteLine("*");
            for (int i = 0; i < UIWidth; i++)
            {
                Console.Write("*");
            }
            Console.WriteLine();
            Console.WriteLine();
        }
        public List<GridType> GridTypes = new List<GridType>();
        Random Rd = new Random();
        public GridType[] Map(int mapLength)
        {
            GridTypes.AddRange(new GridType[] { 
                new GridType("□", "普通地图", 0, 60, "组成地图的基础元素，玩家停留在上面无任何反应"),
                new GridType("☆", "幸之运星", 1, 4, "获得随机前进3-6格的奖励"),
                new GridType("★", "恶魔之星", 2, 5, "获得随机后退2-5格的惩罚"), 
                new GridType("◎", "天降馅饼", 3, 2, "将有机会获得连续掷色子的机会"), 
                new GridType("¤", "迷梦沼泽", 4, 8, "被沼泽困住有可能被困,被困后暂停一轮")
            });
            GridType[] Result = new GridType[mapLength];
            Result[0] = GridTypes[0];
            for (int i = 1; i < mapLength; i++)
            {
                Result[i] = NewGrid();
            }
            return Result;
        }
        /// <summary>
        /// 随机生成一块地图
        /// </summary>
        /// <returns></returns>
        public GridType NewGrid()
        {
            int Sum = 0, Temp = 0, Temp1;
            GridType Result = GridTypes[0];
            foreach (GridType GT in GridTypes)
            {
                Sum += GT.Probability;
            }
            Temp1 = Rd.Next(0, Sum);
            foreach (GridType GT in GridTypes)
            {
                if (Temp1 >= Temp && Temp1 < Temp + GT.Probability)
                {
                    Result = GT;
                }
                Temp += GT.Probability;
            }
            return Result;
        }
        /// <summary>
        /// 掷色子
        /// </summary>
        /// <returns></returns>
        public int dice()
        {
            return Rd.Next(1, 7);
        }
        public int dice(int floor, int upper)
        {
            return Rd.Next(floor, upper);
        }
        public UI()
        {
            GameName = "飞 行 棋";
            UIWidth = 60;
        }
        public UI(string gameName, int uiWidth)
        {
            GameName = gameName;
            UIWidth = uiWidth;
        }
        public UI(string gameName)
            : this(gameName, 60)
        {

        }
    }
}
